package de.mdelab.mlsdm.interpreter.facade;

import java.util.HashMap;
import java.util.Map;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.DecisionMergeNode;
import de.mdelab.sdm.interpreter.core.facade.IDecisionNodeFacade;

/**
 * 
 * @author Stephan Hildebrandt
 * 
 */
public class MLSDMDecisionNodeFacade extends MLSDMActivityNodeFacade implements
		IDecisionNodeFacade<ActivityNode, ActivityEdge, MLExpression>
{

	@Override
	public Map<MLExpression, ActivityEdge> getConditionalNextEdges(final ActivityNode activityNode)
	{
		assert activityNode instanceof DecisionMergeNode;

		final Map<MLExpression, ActivityEdge> map = new HashMap<MLExpression, ActivityEdge>();

		for (final ActivityEdge edge : activityNode.getOutgoingEdges())
		{
			switch (edge.getGuardType())
			{
				case BOOLEAN:
					map.put(edge.getGuardExpression(), edge);
					break;

				case ELSE:
				case NONE:
					break;

				default:
					throw new UnsupportedOperationException();
			}
		}

		return map;
	}

	@Override
	public ActivityEdge getUnconditionalNextEdge(final ActivityNode activityNode)
	{
		assert activityNode instanceof DecisionMergeNode;

		for (final ActivityEdge edge : activityNode.getOutgoingEdges())
		{
			switch (edge.getGuardType())
			{
				case BOOLEAN:
					break;

				case ELSE:
				case NONE:
					return edge;

				default:
					throw new UnsupportedOperationException();
			}
		}

		throw new UnsupportedOperationException();
	}

}
