package de.mdelab.mlsdm.interpreter.facade;

import java.util.Collection;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ExpressionActivityNode;
import de.mdelab.sdm.interpreter.core.facade.IExpressionNodeFacade;

/**
 * 
 * @author Stephan Hildebrandt
 * 
 */
public class MLSDMExpressionNodeFacade extends MLSDMActivityNodeFacade implements
		IExpressionNodeFacade<ActivityNode, ActivityEdge, MLExpression>
{
	@Override
	public Collection<MLExpression> getExpressions(final ActivityNode activityNode)
	{
		assert activityNode != null;
		assert activityNode instanceof ExpressionActivityNode;

		return ((ExpressionActivityNode) activityNode).getExpressions();
	}

	@Override
	public ActivityEdge getNextActivityEdge(final ActivityNode activityNode)
	{
		assert activityNode != null;
		assert activityNode.getOutgoingEdges().size() == 1;

		return activityNode.getOutgoingEdges().get(0);
	}
}
